<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AirlineApplication.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">airline-graph</a> &gt; <a href="index.source.html" class="el_package">com.boxever.challenge.airline</a> &gt; <span class="el_source">AirlineApplication.java</span></div><h1>AirlineApplication.java</h1><pre class="source lang-java linenums">package com.boxever.challenge.airline;

import com.boxever.challenge.airline.algorithms.ShortestPathFinder;
import com.boxever.challenge.airline.exceptions.InputException;
import com.boxever.challenge.airline.model.AirlineGraph;
import com.boxever.challenge.airline.model.AirlinePath;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

@SpringBootApplication
public class AirlineApplication  implements CommandLineRunner {
    private ShortestPathFinder finder;
    private String source;
    private String dest;

    public AirlineApplication(@Value(&quot;${source:DUB}&quot;) String source,
                              @Value(&quot;${dest:LHR}&quot;) String dest,
<span class="fc" id="L21">                              @Autowired ShortestPathFinder shortestPathFinder){</span>
<span class="fc" id="L22">        this.finder = shortestPathFinder;</span>
<span class="fc" id="L23">        this.source = source;</span>
<span class="fc" id="L24">        this.dest = dest;</span>
<span class="fc" id="L25">        this.validateInput();</span>
<span class="fc" id="L26">    }</span>

    @Override
    public void run(String... args) throws Exception {
<span class="fc" id="L30">        AirlinePath path = this.finder.getShortestPath(source, dest);</span>
<span class="fc bfc" id="L31" title="All 2 branches covered.">        if (path.exists()) {</span>
<span class="fc" id="L32">            System.out.println(path);</span>
        } else {
<span class="fc" id="L34">            System.out.println(&quot;No path between &quot; + this.source + &quot; and &quot; + this.dest);</span>
        }
<span class="fc" id="L36">    }</span>

    private void validateInput() throws InputException {
<span class="fc bfc" id="L39" title="All 4 branches covered.">        if (!AirlineGraph.AIRPORTS.contains(source) || !AirlineGraph.AIRPORTS.contains(dest)) {</span>
<span class="fc" id="L40">            throw new InputException(&quot;Source or destination unknowns&quot;);</span>
        }
<span class="fc" id="L42">    }</span>

    public static void main(String[] args) {
<span class="fc" id="L45">        SpringApplication.run(AirlineApplication.class, args);</span>
<span class="fc" id="L46">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.6.202009150832</span></div></body></html>